package com.ebay.redlasersdk;

import android.graphics.PointF;
import android.os.Parcel;
import android.os.Parcelable;

import java.util.AbstractCollection;
import java.util.ArrayList;
import java.util.Date;
import java.util.UUID;

/**
 * Created by mo on 24/08/15.
 */
public class BarcodeResult implements Parcelable {

    public UUID associatedBarcode = null;
    public ArrayList<PointF> barcodeLocation;
    public String barcodeString;
    public int barcodeType;
    public static Parcelable.Creator<BarcodeResult> CREATOR;
    public String extendedBarcodeString;
    public Date firstScanTime;
    public boolean isPartialBarcode;
    public Date mostRecentScanTime;
    public UUID uniqueID;


    public BarcodeResult() {
        barcodeLocation = new ArrayList<PointF>();
        firstScanTime = new Date();
        isPartialBarcode = false;
        mostRecentScanTime = new Date();
        uniqueID = new UUID(0, 0);
    }

    @Override
    public int describeContents() {
        return 0;
    }

    public BarcodeResult getAssociatedBarcode(AbstractCollection<BarcodeResult> resultSet) {
        return null;
    }

    public String getBarcodeType() {
        return ("" + barcodeType);
    }

    @Override
    public int hashCode() {
        String hashable = barcodeString + barcodeType;
        return hashable.hashCode();
    }

    @Override
    public boolean equals(Object o) {
        if (o instanceof BarcodeResult) {
            BarcodeResult resultB = (BarcodeResult) o;
            return barcodeString.equals(resultB.barcodeString) && barcodeType == resultB.barcodeType;
        }
        return false;
    }

    @Override
    public void writeToParcel(Parcel parcel, int i) {
        parcel.writeString(barcodeString);
        parcel.writeInt(barcodeType);
    }
}
