package com.ebay.redlasersdk;

/**
 * Created by mo on 21/08/15.
 */
public class BarcodeTypes {

    private BarcodeScanActivity mCallback;


    public static final int NONE = 0x0;
    public static final int EAN13 = 0x1;
    public static final int UPCE = 0x2;
    public static final int EAN8 = 0x4;
    public static final int QRCODE = 0x10;
    public static final int CODE128 = 0x20;
    public static final int CODE39 = 0x40;
    public static final int DATAMATRIX = 0x80;
    public static final int ITF = 0x100;
    public static final int CODE93 = 0x200;
    public static final int GS1DATABAR = 0x400;
    public static final int RSS14 = GS1DATABAR;
    public static final int CODABAR = 0x800;
    public static final int EAN5 = 0x1000;
    public static final int EAN2 = 0x2000;
    public static final int PDF417 = 0x4000;
    public static final int GS1DATABAR_EXPANDED = 0x8000;

    private int mSymbologies = 0;


    protected void setCallback(BarcodeScanActivity callback) {
        mCallback = callback;
    }

    public boolean getEan13() {
        return (mSymbologies & EAN13) == EAN13;
    }

    public void setEan13(boolean arg) {
        setSymbology(EAN13, arg);
    }

    public boolean getUpce() {
        return (mSymbologies & UPCE) == UPCE;
    }

    public void setUpce(boolean arg) {
        setSymbology(UPCE, arg);
    }

    public boolean getEan8() {
        return (mSymbologies & EAN8) == EAN8;
    }

    public void setEan8(boolean arg) {
        setSymbology(EAN8, arg);
    }

    public boolean getQRCode() {
        return (mSymbologies & QRCODE) == QRCODE;
    }

    public void setQRCode(boolean arg) {
        setSymbology(QRCODE, arg);
    }

    public boolean getCode128() {
        return (mSymbologies & CODE128) == CODE128;
    }

    public void setCode128(boolean arg) {
        setSymbology(CODE128, arg);
    }

    public boolean getCode39() {
        return (mSymbologies & CODE39) == CODE39;
    }

    public void setCode39(boolean arg) {
        setSymbology(CODE39, arg);
    }

    public boolean getDataMatrix() {
        return (mSymbologies & DATAMATRIX) == DATAMATRIX;
    }

    public void setDataMatrix(boolean arg) {
        setSymbology(DATAMATRIX, arg);
    }

    public boolean getITF() {
        return (mSymbologies & ITF) == ITF;
    }

    public void setITF(boolean arg) {
        setSymbology(ITF, arg);
    }

    public boolean getCode93() {
        return (mSymbologies & CODE93) == CODE93;
    }

    public void setCode93(boolean arg) {
        setSymbology(CODE93, arg);
    }

    public boolean getGS1Databar() {
        return (mSymbologies & GS1DATABAR) == GS1DATABAR;
    }

    public void setGS1Databar(boolean arg) {
        setSymbology(GS1DATABAR, arg);
    }

    public boolean getRSS14() {
        return (mSymbologies & RSS14) == RSS14;
    }

    public void setRSS14(boolean arg) {
        setSymbology(RSS14, arg);
    }

    public boolean getCodabar() {
        return (mSymbologies & CODABAR) == CODABAR;
    }

    public void setCodabar(boolean arg) {
        setSymbology(CODABAR, arg);
    }

    public boolean getEAN5() {
        return (mSymbologies & EAN5) == EAN5;
    }

    public void setEan5(boolean arg) {
        setSymbology(EAN5, arg);
    }

    public boolean getEAN2() {
        return (mSymbologies & EAN2) == EAN2;
    }

    public void setEan2(boolean arg) {
        setSymbology(EAN2, arg);
    }

    public boolean getPDF417() {
        return (mSymbologies & PDF417) == PDF417;
    }

    public void setPDF417(boolean arg) {
        setSymbology(PDF417, arg);
    }

    public boolean getGS1DatabarExpanded() {
        return (mSymbologies & GS1DATABAR_EXPANDED) == GS1DATABAR_EXPANDED;
    }

    public void setGS1DatabarExpanded(boolean arg) {
        setSymbology(GS1DATABAR_EXPANDED, arg);
    }

    public int getEnabledTypes() {
        return mSymbologies;
    }

    public boolean getSticky() {
        return false;
    }

    public void setSticky(boolean arg) {

    }

    private void setSymbology(int symbology, boolean enabled) {
        if (enabled) {
            mSymbologies = (mSymbologies | symbology);
        } else {
            mSymbologies = (mSymbologies & ~symbology);
        }
        mCallback.barcodeTypesDidUpdate(symbology, enabled);
    }
}
